-- License CC0 (Creative Commons license) (c) darkfrei, 2023

love.window.setMode(10*16*8, 9*16*8)
Width, Height = love.graphics.getDimensions( )

print ('window resolution', Width, Height)


local iso = require ('isolines-and-isobands')


--local noise = iso.createNoise() -- default noise
local noise = iso.createNoise(noiseFunction, shiftX, shiftY, 0.3, 0.3, 0)

-- noise grid is 1 bigger than amount of cells:
Columns, Rows = 10, 9

NoiseGrid = iso.createNoiseGrid (Columns, Rows, noise)


-- scale will be used as cell size for the grid
Scale = math.floor(math.min(Width/(Columns), Height/(Rows)))

print ('grid: columns:'..Columns..' rows: '..Rows..' scale:'..Scale)

Isovalue1 = 0.5


Isolines = iso.createIsolines (Isovalue1, Scale, NoiseGrid)
print ('isolines:'..#Isolines)






function update ()
	noiseMap = createnoiseMap (width, height, windowX, windowY, kx, ky)
	isolines = createIsolines (noiseMap, width, height)
	noisePoints = createNoisePoints (noiseMap, width, height)
	polygons = createPolygons (noiseMap, width, height)
end

function love.load()
--	update ()
end


local function drawBackground (Scale)
	for y = iso.yMin, iso.yMax-1 do
		for x = iso.xMin, iso.xMax-1 do
			local c = 0.08*((x+y)%2)+0.27
			love.graphics.setColor (c,c,c)
			love.graphics.rectangle ('fill', (x-1)*Scale, (y-1)*Scale, Scale, Scale)
		end
	end
end

local function drawGridValuesAsCircles (grid, gridSize, isovalue)
	for y = iso.yMin, iso.yMax do
		for x = iso.xMin, iso.xMax do
			local value = grid[y][x]
			if isovalue < value then
				love.graphics.setColor (1,1,0)
			else
				love.graphics.setColor (1,1,1)
			end
			love.graphics.circle ('line', (x-1)*gridSize, (y-1)*gridSize, value*gridSize/2)
		end
	end
end

local function drawIsolines (isolines)
	for i, line in ipairs (isolines) do
		love.graphics.line (line)
	end
end

function love.draw()
	-- example to draw values:
	drawBackground (Scale)
	
	-- example to draw values:
	drawGridValuesAsCircles (NoiseGrid, Scale, Isovalue1)
	
	-- example to draw isolines:
	drawIsolines (Isolines)
	
	
	
--	love.graphics.translate (-scale/2,-scale/2)
--	love.graphics.scale (scale)
--	love.graphics.setLineWidth (1/(2*scale))
--	love.graphics.points (noisePoints)
--	for i, line in ipairs (isolines) do
--		love.graphics.line (line)
--	end
	
--	if polygons then
--		for i, polygon in ipairs (polygons) do
--			love.graphics.polygon ('fill', polygon)
--		end
--	end
	
--	if polygon then
--		love.graphics.polygon ('fill', polygon)
--	end
end

function love.keypressed(key, scancode, isrepeat)
	if false then
	elseif key == "escape" then
		love.event.quit()
	end
end

--function love.mousemoved( x, y, dx, dy, istouch )
--	if love.mouse.isDown (1) then
--		windowX = windowX+dx/scale
--		windowY = windowY+dy/scale
--		update ()
--	end
	
--	local nx = math.floor(x/scale+0.5)
--	local ny = math.floor(y/scale+0.5)
--	polygon = createIsopolygon (noiseMap, nx, ny, isovalue, isovalue+0.05)
----	love.window.setTitle ('nx: '..nx..' ny:'..ny)
--end

--function love.wheelmoved(x, y)
--	if y > 0 then
--		isovalue = isovalue + 0.05
--		love.window.setTitle ('isovalue: '..isovalue)
--		update ()
--	elseif y < 0 then
--		isovalue = isovalue - 0.05
--		love.window.setTitle ('isovalue: '..isovalue)
--		update ()
--	end
--end
